Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.json
Class JSONObject

    java.lang.Object
      org.json.JSONObject

    public class JSONObject

extends java.lang.Object

A JSONObject is an unordered collection of name/value pairs. Its external form is a string wrapped in curly braces with colons between the names and values, and commas between the values and names. The internal form is an object having `get` and `opt` methods for accessing the values by name, and `put` methods for adding or replacing values by name. The values can be any of these types: `Boolean`, `JSONArray`, `JSONObject`, `Number`, `String`, or the `JSONObject.NULL` object. A JSONObject constructor can be used to convert an external form JSON text into an internal form whose values can be retrieved with the `get` and `opt` methods, or to convert values into a JSON text using the `put` and `toString` methods. A `get` method returns a value if one can be found, and throws an exception if one cannot be found. An `opt` method returns a default value instead of throwing an exception, and so is useful for obtaining optional values.

The generic `get()` and `opt()` methods return an object, which you can cast or query for type. There are also typed `get` and `opt` methods that do type checking and type coercion for you.

The `put` methods adds values to an object. For example,

         myString = new JSONObject().put("JSON", "Hello, World!").toString();

produces the string `{"JSON": "Hello, World"}`.

The texts produced by the `toString` methods strictly conform to the JSON syntax rules. The constructors are more forgiving in the texts they will accept:

- An extra `,` (comma) may appear just before the closing brace.
- Strings may be quoted with `'` (single quote).
- Strings do not need to be quoted at all if they do not begin with a quote or single quote, and if they do not contain leading or trailing spaces, and if they do not contain any of these characters: `{ } [ ] / \ : , = ; #` and if they do not look like numbers and if they are not the reserved words `true`, `false`, or `null`.
- Keys can be followed by `=` or `=>` as well as by `:`.
- Values can be followed by `;` (semicolon) as well as by `,` (comma).
- Numbers may have the `0x-` (hex) prefix.

Version:
  2010-05-17
Author:
  JSON.org

Nested Class Summary
`private static class` | `JSONObject.Null` JSONObject.NULL is equivalent to the value that JavaScript calls null, whilst Java's null is equivalent to the value that JavaScript calls undefined.

Field Summary
`private java.util.Map` | `map` The map where the JSONObject's properties are kept.
`static java.lang.Object` | `NULL` It is sometimes more convenient and less ambiguous to have a `NULL` object than to use Java's `null` value.

Constructor Summary
`JSONObject()` Construct an empty JSONObject.
`JSONObject(JSONObject jo, java.lang.String[] names)` Construct a JSONObject from a subset of another JSONObject.
`JSONObject(JSONTokener x)` Construct a JSONObject from a JSONTokener.
`JSONObject(java.util.Map map)` Construct a JSONObject from a Map.
`JSONObject(java.lang.Object bean)` Construct a JSONObject from an Object using bean getters.
`JSONObject(java.lang.Object object, java.lang.String[] names)` Construct a JSONObject from an Object, using reflection to find the public members.
`JSONObject(java.lang.String source)` Construct a JSONObject from a source JSON text string.

Method Summary
`JSONObject` | `accumulate(java.lang.String key, java.lang.Object value)` Accumulate values under a key.
`JSONObject` | `append(java.lang.String key, java.lang.Object value)` Append values to the array under a key.
`static java.lang.String` | `doubleToString(double d)` Produce a string from a double.
`java.lang.Object` | `get(java.lang.String key)` Get the value object associated with a key.
`boolean` | `getBoolean(java.lang.String key)` Get the boolean value associated with a key.
`double` | `getDouble(java.lang.String key)` Get the double value associated with a key.
`int` | `getInt(java.lang.String key)` Get the int value associated with a key.
`JSONArray` | `getJSONArray(java.lang.String key)` Get the JSONArray value associated with a key.
`JSONObject` | `getJSONObject(java.lang.String key)` Get the JSONObject value associated with a key.
`long` | `getLong(java.lang.String key)` Get the long value associated with a key.
`static java.lang.String[]` | `getNames(JSONObject jo)` Get an array of field names from a JSONObject.
`static java.lang.String[]` | `getNames(java.lang.Object object)` Get an array of field names from an Object.
`java.lang.String` | `getString(java.lang.String key)` Get the string associated with a key.
`boolean` | `has(java.lang.String key)` Determine if the JSONObject contains a specific key.
`JSONObject` | `increment(java.lang.String key)` Increment a property of a JSONObject.
`boolean` | `isNull(java.lang.String key)` Determine if the value associated with the key is null or if there is no value.
`java.util.Iterator` | `keys()` Get an enumeration of the keys of the JSONObject.
`int` | `length()` Get the number of keys stored in the JSONObject.
`JSONArray` | `names()` Produce a JSONArray containing the names of the elements of this JSONObject.
`static java.lang.String` | `numberToString(java.lang.Number n)` Produce a string from a Number.
`java.lang.Object` | `opt(java.lang.String key)` Get an optional value associated with a key.
`boolean` | `optBoolean(java.lang.String key)` Get an optional boolean associated with a key.
`boolean` | `optBoolean(java.lang.String key, boolean defaultValue)` Get an optional boolean associated with a key.
`double` | `optDouble(java.lang.String key)` Get an optional double associated with a key, or NaN if there is no such key or if its value is not a number.
`double` | `optDouble(java.lang.String key, double defaultValue)` Get an optional double associated with a key, or the defaultValue if there is no such key or if its value is not a number.
`int` | `optInt(java.lang.String key)` Get an optional int value associated with a key, or zero if there is no such key or if the value is not a number.
`int` | `optInt(java.lang.String key, int defaultValue)` Get an optional int value associated with a key, or the default if there is no such key or if the value is not a number.
`JSONArray` | `optJSONArray(java.lang.String key)` Get an optional JSONArray associated with a key.
`JSONObject` | `optJSONObject(java.lang.String key)` Get an optional JSONObject associated with a key.
`long` | `optLong(java.lang.String key)` Get an optional long value associated with a key, or zero if there is no such key or if the value is not a number.
`long` | `optLong(java.lang.String key, long defaultValue)` Get an optional long value associated with a key, or the default if there is no such key or if the value is not a number.
`java.lang.String` | `optString(java.lang.String key)` Get an optional string associated with a key.
`java.lang.String` | `optString(java.lang.String key, java.lang.String defaultValue)` Get an optional string associated with a key.
`private void` | `populateMap(java.lang.Object bean)`
`JSONObject` | `put(java.lang.String key, boolean value)` Put a key/boolean pair in the JSONObject.
`JSONObject` | `put(java.lang.String key, java.util.Collection value)` Put a key/value pair in the JSONObject, where the value will be a JSONArray which is produced from a Collection.
`JSONObject` | `put(java.lang.String key, double value)` Put a key/double pair in the JSONObject.
`JSONObject` | `put(java.lang.String key, int value)` Put a key/int pair in the JSONObject.
`JSONObject` | `put(java.lang.String key, long value)` Put a key/long pair in the JSONObject.
`JSONObject` | `put(java.lang.String key, java.util.Map value)` Put a key/value pair in the JSONObject, where the value will be a JSONObject which is produced from a Map.
`JSONObject` | `put(java.lang.String key, java.lang.Object value)` Put a key/value pair in the JSONObject.
`JSONObject` | `putOnce(java.lang.String key, java.lang.Object value)` Put a key/value pair in the JSONObject, but only if the key and the value are both non-null, and only if there is not already a member with that name.
`JSONObject` | `putOpt(java.lang.String key, java.lang.Object value)` Put a key/value pair in the JSONObject, but only if the key and the value are both non-null.
`static java.lang.String` | `quote(java.lang.String string)` Produce a string in double quotes with backslash sequences in all the right places.
`java.lang.Object` | `remove(java.lang.String key)` Remove a name and its value, if present.
`java.util.Iterator` | `sortedKeys()` Get an enumeration of the keys of the JSONObject.
`static java.lang.Object` | `stringToValue(java.lang.String s)` Try to convert a string into a number, boolean, or null.
`(package private) static void` | `testValidity(java.lang.Object o)` Throw an exception if the object is an NaN or infinite number.
`JSONArray` | `toJSONArray(JSONArray names)` Produce a JSONArray containing the values of the members of this JSONObject.
`java.lang.String` | `toString()` Make a JSON text of this JSONObject.
`java.lang.String` | `toString(int indentFactor)` Make a prettyprinted JSON text of this JSONObject.
`(package private) java.lang.String` | `toString(int indentFactor, int indent)` Make a prettyprinted JSON text of this JSONObject.
`(package private) static java.lang.String` | `valueToString(java.lang.Object value)` Make a JSON text of an Object value.
`(package private) static java.lang.String` | `valueToString(java.lang.Object value, int indentFactor, int indent)` Make a prettyprinted JSON text of an object value.
`(package private) static java.lang.Object` | `wrap(java.lang.Object object)` Wrap an object, if necessary.
`java.io.Writer` | `write(java.io.Writer writer)` Write the contents of the JSONObject as JSON text to a writer.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### map

    private java.util.Map map

  The map where the JSONObject's properties are kept.

### NULL

    public static final java.lang.Object NULL

  It is sometimes more convenient and less ambiguous to have a `NULL` object than to use Java's `null` value. `JSONObject.NULL.equals(null)` returns `true`. `JSONObject.NULL.toString()` returns `"null"`.

Constructor Detail

### JSONObject

    public JSONObject()

  Construct an empty JSONObject.

### JSONObject

    public JSONObject(JSONObject jo,
                      java.lang.String[] names)

  Construct a JSONObject from a subset of another JSONObject. An array of strings is used to identify the keys that should be copied. Missing keys are ignored.

  Parameters:
    `jo` - A JSONObject.
    `names` - An array of strings.
  Throws:
    `JSONException`
    `JSONException` - If a value is a non-finite number or if a name is duplicated.

### JSONObject

    public JSONObject(JSONTokener x)
               throws JSONException

  Construct a JSONObject from a JSONTokener.

  Parameters:
    `x` - A JSONTokener object containing the source string.
  Throws:
    `JSONException` - If there is a syntax error in the source string or a duplicated key.

### JSONObject

    public JSONObject(java.util.Map map)

  Construct a JSONObject from a Map.

  Parameters:
    `map` - A map object that can be used to initialize the contents of the JSONObject.
  Throws:
    `JSONException`

### JSONObject

    public JSONObject(java.lang.Object bean)

  Construct a JSONObject from an Object using bean getters. It reflects on all of the public methods of the object. For each of the methods with no parameters and a name starting with `"get"` or `"is"` followed by an uppercase letter, the method is invoked, and a key and the value returned from the getter method are put into the new JSONObject. The key is formed by removing the `"get"` or `"is"` prefix. If the second remaining character is not upper case, then the first character is converted to lower case. For example, if an object has a method named `"getName"`, and if the result of calling `object.getName()` is `"Larry Fine"`, then the JSONObject will contain `"name": "Larry Fine"`.

  Parameters:
    `bean` - An object that has getter methods that should be used to make a JSONObject.

### JSONObject

    public JSONObject(java.lang.Object object,
                      java.lang.String[] names)

  Construct a JSONObject from an Object, using reflection to find the public members. The resulting JSONObject's keys will be the strings from the names array, and the values will be the field values associated with those keys in the object. If a key is not found or not visible, then it will not be copied into the new JSONObject.

  Parameters:
    `object` - An object that has fields that should be used to make a JSONObject.
    `names` - An array of strings, the names of the fields to be obtained from the object.

### JSONObject

    public JSONObject(java.lang.String source)
               throws JSONException

  Construct a JSONObject from a source JSON text string. This is the most commonly used JSONObject constructor.

  Parameters:
    `source` - A string beginning with `{` (left brace) and ending with `}` (right brace).
  Throws:
    `JSONException` - If there is a syntax error in the source string or a duplicated key.

Method Detail

### accumulate

    public JSONObject accumulate(java.lang.String key,
                                 java.lang.Object value)
                          throws JSONException

  Accumulate values under a key. It is similar to the put method except that if there is already an object stored under the key then a JSONArray is stored under the key to hold all of the accumulated values. If there is already a JSONArray, then the new value is appended to it. In contrast, the put method replaces the previous value.

  Parameters:
    `key` - A key string.
    `value` - An object to be accumulated under the key.
  Returns:
    this.
  Throws:
    `JSONException` - If the value is an invalid number or if the key is null.

### append

    public JSONObject append(java.lang.String key,
                             java.lang.Object value)
                      throws JSONException

  Append values to the array under a key. If the key does not exist in the JSONObject, then the key is put in the JSONObject with its value being a JSONArray containing the value parameter. If the key was already associated with a JSONArray, then the value parameter is appended to it.

  Parameters:
    `key` - A key string.
    `value` - An object to be accumulated under the key.
  Returns:
    this.
  Throws:
    `JSONException` - If the key is null or if the current value associated with the key is not a JSONArray.

### doubleToString

    public static java.lang.String doubleToString(double d)

  Produce a string from a double. The string "null" will be returned if the number is not finite.

  Parameters:
    `d` - A double.
  Returns:
    A String.

### get

    public java.lang.Object get(java.lang.String key)
                         throws JSONException

  Get the value object associated with a key.

  Parameters:
    `key` - A key string.
  Returns:
    The object associated with the key.
  Throws:
    `JSONException` - if the key is not found.

### getBoolean

    public boolean getBoolean(java.lang.String key)
                       throws JSONException

  Get the boolean value associated with a key.

  Parameters:
    `key` - A key string.
  Returns:
    The truth.
  Throws:
    `JSONException` - if the value is not a Boolean or the String "true" or "false".

### getDouble

    public double getDouble(java.lang.String key)
                     throws JSONException

  Get the double value associated with a key.

  Parameters:
    `key` - A key string.
  Returns:
    The numeric value.
  Throws:
    `JSONException` - if the key is not found or if the value is not a Number object and cannot be converted to a number.

### getInt

    public int getInt(java.lang.String key)
               throws JSONException

  Get the int value associated with a key.

  Parameters:
    `key` - A key string.
  Returns:
    The integer value.
  Throws:
    `JSONException` - if the key is not found or if the value cannot be converted to an integer.

### getJSONArray

    public JSONArray getJSONArray(java.lang.String key)
                           throws JSONException

  Get the JSONArray value associated with a key.

  Parameters:
    `key` - A key string.
  Returns:
    A JSONArray which is the value.
  Throws:
    `JSONException` - if the key is not found or if the value is not a JSONArray.

### getJSONObject

    public JSONObject getJSONObject(java.lang.String key)
                             throws JSONException

  Get the JSONObject value associated with a key.

  Parameters:
    `key` - A key string.
  Returns:
    A JSONObject which is the value.
  Throws:
    `JSONException` - if the key is not found or if the value is not a JSONObject.

### getLong

    public long getLong(java.lang.String key)
                 throws JSONException

  Get the long value associated with a key.

  Parameters:
    `key` - A key string.
  Returns:
    The long value.
  Throws:
    `JSONException` - if the key is not found or if the value cannot be converted to a long.

### getNames

    public static java.lang.String[] getNames(JSONObject jo)

  Get an array of field names from a JSONObject.

  Returns:
    An array of field names, or null if there are no names.

### getNames

    public static java.lang.String[] getNames(java.lang.Object object)

  Get an array of field names from an Object.

  Returns:
    An array of field names, or null if there are no names.

### getString

    public java.lang.String getString(java.lang.String key)
                               throws JSONException

  Get the string associated with a key.

  Parameters:
    `key` - A key string.
  Returns:
    A string which is the value.
  Throws:
    `JSONException` - if the key is not found.

### has

    public boolean has(java.lang.String key)

  Determine if the JSONObject contains a specific key.

  Parameters:
    `key` - A key string.
  Returns:
    true if the key exists in the JSONObject.

### increment

    public JSONObject increment(java.lang.String key)
                         throws JSONException

  Increment a property of a JSONObject. If there is no such property, create one with a value of 1. If there is such a property, and if it is an Integer, Long, Double, or Float, then add one to it.

  Parameters:
    `key` - A key string.
  Returns:
    this.
  Throws:
    `JSONException` - If there is already a property with this name that is not an Integer, Long, Double, or Float.

### isNull

    public boolean isNull(java.lang.String key)

  Determine if the value associated with the key is null or if there is no value.

  Parameters:
    `key` - A key string.
  Returns:
    true if there is no value associated with the key or if the value is the JSONObject.NULL object.

### keys

    public java.util.Iterator keys()

  Get an enumeration of the keys of the JSONObject.

  Returns:
    An iterator of the keys.

### length

    public int length()

  Get the number of keys stored in the JSONObject.

  Returns:
    The number of keys in the JSONObject.

### names

    public JSONArray names()

  Produce a JSONArray containing the names of the elements of this JSONObject.

  Returns:
    A JSONArray containing the key strings, or null if the JSONObject is empty.

### numberToString

    public static java.lang.String numberToString(java.lang.Number n)
                                           throws JSONException

  Produce a string from a Number.

  Parameters:
    `n` - A Number
  Returns:
    A String.
  Throws:
    `JSONException` - If n is a non-finite number.

### opt

    public java.lang.Object opt(java.lang.String key)

  Get an optional value associated with a key.

  Parameters:
    `key` - A key string.
  Returns:
    An object which is the value, or null if there is no value.

### optBoolean

    public boolean optBoolean(java.lang.String key)

  Get an optional boolean associated with a key. It returns false if there is no such key, or if the value is not Boolean.TRUE or the String "true".

  Parameters:
    `key` - A key string.
  Returns:
    The truth.

### optBoolean

    public boolean optBoolean(java.lang.String key,
                              boolean defaultValue)

  Get an optional boolean associated with a key. It returns the defaultValue if there is no such key, or if it is not a Boolean or the String "true" or "false" (case insensitive).

  Parameters:
    `key` - A key string.
    `defaultValue` - The default.
  Returns:
    The truth.

### optDouble

    public double optDouble(java.lang.String key)

  Get an optional double associated with a key, or NaN if there is no such key or if its value is not a number. If the value is a string, an attempt will be made to evaluate it as a number.

  Parameters:
    `key` - A string which is the key.
  Returns:
    An object which is the value.

### optDouble

    public double optDouble(java.lang.String key,
                            double defaultValue)

  Get an optional double associated with a key, or the defaultValue if there is no such key or if its value is not a number. If the value is a string, an attempt will be made to evaluate it as a number.

  Parameters:
    `key` - A key string.
    `defaultValue` - The default.
  Returns:
    An object which is the value.

### optInt

    public int optInt(java.lang.String key)

  Get an optional int value associated with a key, or zero if there is no such key or if the value is not a number. If the value is a string, an attempt will be made to evaluate it as a number.

  Parameters:
    `key` - A key string.
  Returns:
    An object which is the value.

### optInt

    public int optInt(java.lang.String key,
                      int defaultValue)

  Get an optional int value associated with a key, or the default if there is no such key or if the value is not a number. If the value is a string, an attempt will be made to evaluate it as a number.

  Parameters:
    `key` - A key string.
    `defaultValue` - The default.
  Returns:
    An object which is the value.

### optJSONArray

    public JSONArray optJSONArray(java.lang.String key)

  Get an optional JSONArray associated with a key. It returns null if there is no such key, or if its value is not a JSONArray.

  Parameters:
    `key` - A key string.
  Returns:
    A JSONArray which is the value.

### optJSONObject

    public JSONObject optJSONObject(java.lang.String key)

  Get an optional JSONObject associated with a key. It returns null if there is no such key, or if its value is not a JSONObject.

  Parameters:
    `key` - A key string.
  Returns:
    A JSONObject which is the value.

### optLong

    public long optLong(java.lang.String key)

  Get an optional long value associated with a key, or zero if there is no such key or if the value is not a number. If the value is a string, an attempt will be made to evaluate it as a number.

  Parameters:
    `key` - A key string.
  Returns:
    An object which is the value.

### optLong

    public long optLong(java.lang.String key,
                        long defaultValue)

  Get an optional long value associated with a key, or the default if there is no such key or if the value is not a number. If the value is a string, an attempt will be made to evaluate it as a number.

  Parameters:
    `key` - A key string.
    `defaultValue` - The default.
  Returns:
    An object which is the value.

### optString

    public java.lang.String optString(java.lang.String key)

  Get an optional string associated with a key. It returns an empty string if there is no such key. If the value is not a string and is not null, then it is coverted to a string.

  Parameters:
    `key` - A key string.
  Returns:
    A string which is the value.

### optString

    public java.lang.String optString(java.lang.String key,
                                      java.lang.String defaultValue)

  Get an optional string associated with a key. It returns the defaultValue if there is no such key.

  Parameters:
    `key` - A key string.
    `defaultValue` - The default.
  Returns:
    A string which is the value.

### populateMap

    private void populateMap(java.lang.Object bean)

### put

    public JSONObject put(java.lang.String key,
                          boolean value)
                   throws JSONException

  Put a key/boolean pair in the JSONObject.

  Parameters:
    `key` - A key string.
    `value` - A boolean which is the value.
  Returns:
    this.
  Throws:
    `JSONException` - If the key is null.

### put

    public JSONObject put(java.lang.String key,
                          java.util.Collection value)
                   throws JSONException

  Put a key/value pair in the JSONObject, where the value will be a JSONArray which is produced from a Collection.

  Parameters:
    `key` - A key string.
    `value` - A Collection value.
  Returns:
    this.
  Throws:
    `JSONException`

### put

    public JSONObject put(java.lang.String key,
                          double value)
                   throws JSONException

  Put a key/double pair in the JSONObject.

  Parameters:
    `key` - A key string.
    `value` - A double which is the value.
  Returns:
    this.
  Throws:
    `JSONException` - If the key is null or if the number is invalid.

### put

    public JSONObject put(java.lang.String key,
                          int value)
                   throws JSONException

  Put a key/int pair in the JSONObject.

  Parameters:
    `key` - A key string.
    `value` - An int which is the value.
  Returns:
    this.
  Throws:
    `JSONException` - If the key is null.

### put

    public JSONObject put(java.lang.String key,
                          long value)
                   throws JSONException

  Put a key/long pair in the JSONObject.

  Parameters:
    `key` - A key string.
    `value` - A long which is the value.
  Returns:
    this.
  Throws:
    `JSONException` - If the key is null.

### put

    public JSONObject put(java.lang.String key,
                          java.util.Map value)
                   throws JSONException

  Put a key/value pair in the JSONObject, where the value will be a JSONObject which is produced from a Map.

  Parameters:
    `key` - A key string.
    `value` - A Map value.
  Returns:
    this.
  Throws:
    `JSONException`

### put

    public JSONObject put(java.lang.String key,
                          java.lang.Object value)
                   throws JSONException

  Put a key/value pair in the JSONObject. If the value is null, then the key will be removed from the JSONObject if it is present.

  Parameters:
    `key` - A key string.
    `value` - An object which is the value. It should be of one of these types: Boolean, Double, Integer, JSONArray, JSONObject, Long, String, or the JSONObject.NULL object.
  Returns:
    this.
  Throws:
    `JSONException` - If the value is non-finite number or if the key is null.

### putOnce

    public JSONObject putOnce(java.lang.String key,
                              java.lang.Object value)
                       throws JSONException

  Put a key/value pair in the JSONObject, but only if the key and the value are both non-null, and only if there is not already a member with that name.

  Parameters:
    `key` -
    `value` -
  Returns:
    his.
  Throws:
    `JSONException` - if the key is a duplicate

### putOpt

    public JSONObject putOpt(java.lang.String key,
                             java.lang.Object value)
                      throws JSONException

  Put a key/value pair in the JSONObject, but only if the key and the value are both non-null.

  Parameters:
    `key` - A key string.
    `value` - An object which is the value. It should be of one of these types: Boolean, Double, Integer, JSONArray, JSONObject, Long, String, or the JSONObject.NULL object.
  Returns:
    this.
  Throws:
    `JSONException` - If the value is a non-finite number.

### quote

    public static java.lang.String quote(java.lang.String string)

  Produce a string in double quotes with backslash sequences in all the right places. A backslash will be inserted within
  Parameters:
    `string` - A String
  Returns:
    A String correctly formatted for insertion in a JSON text.

### remove

    public java.lang.Object remove(java.lang.String key)

  Remove a name and its value, if present.

  Parameters:
    `key` - The name to be removed.
  Returns:
    The value that was associated with the name, or null if there was no value.

### sortedKeys

    public java.util.Iterator sortedKeys()

  Get an enumeration of the keys of the JSONObject. The keys will be sorted alphabetically.

  Returns:
    An iterator of the keys.

### stringToValue

    public static java.lang.Object stringToValue(java.lang.String s)

  Try to convert a string into a number, boolean, or null. If the string can't be converted, return the string.

  Parameters:
    `s` - A String.
  Returns:
    A simple JSON value.

### testValidity

    static void testValidity(java.lang.Object o)
                      throws JSONException

  Throw an exception if the object is an NaN or infinite number.

  Parameters:
    `o` - The object to test.
  Throws:
    `JSONException` - If o is a non-finite number.

### toJSONArray

    public JSONArray toJSONArray(JSONArray names)
                          throws JSONException

  Produce a JSONArray containing the values of the members of this JSONObject.

  Parameters:
    `names` - A JSONArray containing a list of key strings. This determines the sequence of the values in the result.
  Returns:
    A JSONArray of values.
  Throws:
    `JSONException` - If any of the values are non-finite numbers.

### toString

    public java.lang.String toString()

  Make a JSON text of this JSONObject. For compactness, no whitespace is added. If this would not result in a syntactically correct JSON text, then null will be returned instead.

  Warning: This method assumes that the data structure is acyclical.

  Overrides:
    `toString` in class `java.lang.Object`
  Returns:
    a printable, displayable, portable, transmittable representation of the object, beginning with `{` (left brace) and ending with `}` (right brace).

### toString

    public java.lang.String toString(int indentFactor)
                              throws JSONException

  Make a prettyprinted JSON text of this JSONObject.

  Warning: This method assumes that the data structure is acyclical.

  Parameters:
    `indentFactor` - The number of spaces to add to each level of indentation.
  Returns:
    a printable, displayable, portable, transmittable representation of the object, beginning with `{` (left brace) and ending with `}` (right brace).
  Throws:
    `JSONException` - If the object contains an invalid number.

### toString

    java.lang.String toString(int indentFactor,
                              int indent)
                        throws JSONException

  Make a prettyprinted JSON text of this JSONObject.

  Warning: This method assumes that the data structure is acyclical.

  Parameters:
    `indentFactor` - The number of spaces to add to each level of indentation.
    `indent` - The indentation of the top level.
  Returns:
    a printable, displayable, transmittable representation of the object, beginning with `{` (left brace) and ending with `}` (right brace).
  Throws:
    `JSONException` - If the object contains an invalid number.

### valueToString

    static java.lang.String valueToString(java.lang.Object value)
                                   throws JSONException

  Make a JSON text of an Object value. If the object has an value.toJSONString() method, then that method will be used to produce the JSON text. The method is required to produce a strictly conforming text. If the object does not contain a toJSONString method (which is the most common case), then a text will be produced by other means. If the value is an array or Collection, then a JSONArray will be made from it and its toJSONString method will be called. If the value is a MAP, then a JSONObject will be made from it and its toJSONString method will be called. Otherwise, the value's toString method will be called, and the result will be quoted.

  Warning: This method assumes that the data structure is acyclical.

  Parameters:
    `value` - The value to be serialized.
  Returns:
    a printable, displayable, transmittable representation of the object, beginning with `{` (left brace) and ending with `}` (right brace).
  Throws:
    `JSONException` - If the value is or contains an invalid number.

### valueToString

    static java.lang.String valueToString(java.lang.Object value,
                                          int indentFactor,
                                          int indent)
                                   throws JSONException

  Make a prettyprinted JSON text of an object value.

  Warning: This method assumes that the data structure is acyclical.

  Parameters:
    `value` - The value to be serialized.
    `indentFactor` - The number of spaces to add to each level of indentation.
    `indent` - The indentation of the top level.
  Returns:
    a printable, displayable, transmittable representation of the object, beginning with `{` (left brace) and ending with `}` (right brace).
  Throws:
    `JSONException` - If the object contains an invalid number.

### wrap

    static java.lang.Object wrap(java.lang.Object object)

  Wrap an object, if necessary. If the object is null, return the NULL object. If it is an array or collection, wrap it in a JSONArray. If it is a map, wrap it in a JSONObject. If it is a standard property (Double, String, et al) then it is already wrapped. Otherwise, if it comes from one of the java packages, turn it into a string. And if it doesn't, try to wrap it in a JSONObject. If the wrapping fails, then null is returned.

  Parameters:
    `object` - The object to wrap
  Returns:
    The wrapped value

### write

    public java.io.Writer write(java.io.Writer writer)
                         throws JSONException

  Write the contents of the JSONObject as JSON text to a writer. For compactness, no whitespace is added.

  Warning: This method assumes that the data structure is acyclical.

  Returns:
    The writer.
  Throws:
    `JSONException`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD